#! /usr/bin/perl -w

use Getopt::Std;
use strict;
use warnings;

our($opt_p, $opt_f, $opt_o, $opt_n);
my $path;
my $filename;
my $output;
my $start;
my $counter;
my $line;
my $offset;
my $coord;
my $end;
my $name;
my $final_name;
my %renamed;
my $first_line;
my $pre_chr; 
my $pre_start;
my $pre_stop;
my $pre_count;
my $chr;
my $stop; 
my $count;

#get command line options

getopt("pfon");
getopts("pfon:");

#if insufficient options, print usage

if(! (($opt_p)&&($opt_f)&&($opt_o)&&($opt_n)))
        {
        print "\n\nUsage: $0\n\n";
        print "\tREQUIRED:\n";
        print "\t-p full path of the directory to be checked\n";
	print "\t-f full path and name of the renamed_chromosomes.txt file\n";
	print "\t-o full path to output folder\n";
	print "\t-n name of the final positive BED file (no path)\n";
        die "\n\n";
        }


#set paramaters
$path=$opt_p;
$output=$opt_o;
$filename=$opt_f;
$final_name=$opt_n;


#rename read in the renamed_chromosomes.txt file
open(IN, $filename) or die "Can't open $filename because $!\n";
while(my $line=<IN>)
	{
	chomp($line);
	$line=~s/\.fa//g;
	($chr, $name)=split(/\t/, $line);
	$renamed{$name}=$chr;
	}
close(IN);


#probe each of the directories
while($filename=glob("$path/Unique*"))
	{
	$counter=0;	
	open(IN, $filename) or die "Can't open $filename because $!\n";
	print STDOUT "Processing file name: $filename...\t";
	$chr=$filename;
        $chr=~s/$path\///g;
        $chr=~s/\///g;
        $chr=~s/Unique//g;
        $chr=~s/Length.*//g;
        $chr=~s/Chr/chr/g;

	#substitute chromosome name from the hash
        $chr=$renamed{$chr};
	print STDOUT "chromosome: $chr\n";

	$filename=~s/$path\///g;
	open(OUT, ">$output/$chr.$filename.track") or die "Can't open $output/$chr.$filename.track because $!\n";
	
	while($line=<IN>)
		{
		chomp($line);
		$offset=0;
		$coord=index($line, '1', $offset);
		while ($coord != -1)
			{
			$start=$counter+$coord;
			$end=$start+1;
			print OUT "$chr\t$start\t$end\t1\n";
			$offset=$coord+1;
			$coord=index($line, '1', $offset);
			}
		$counter=$counter+100;
		}
	close(IN);
	close(OUT);


	#now condense the BED file into a single output
	
	open(IN, "$output/$chr.$filename.track") or die "Can't open $filename because $!\n";
        open(OUT, ">>$output/$final_name") or die "Can't open $output/$final_name because $!\n";

        $first_line=<IN>;
        chomp($first_line);
        ($pre_chr, $pre_start, $pre_stop, $pre_count) = split (/\t/, $first_line);

        while ($line=<IN>)
                {
                chomp($line);
                ($chr, $start, $stop, $count)= split(/\t/, $line);
                if (($chr eq $pre_chr)&&($start eq $pre_stop)&&($count eq $pre_count))
                        {
                        #merge current results with previous results
                        $pre_stop=$stop;
                        }
                        else
                        {
                        #print out prior results and reassign variables to the current variables
                        print OUT "$pre_chr\t$pre_start\t$pre_stop\t$pre_count\n";
                        $pre_chr=$chr;
                        $pre_start=$start;
                        $pre_stop=$stop;
                        $pre_count=$count;
                        }
                }
        print OUT "$pre_chr\t$pre_start\t$pre_stop\t$pre_count\n";
        close(IN);
        close(OUT);

	unlink("$output/$chr.$filename.track");

	}
exit(0);
